Subject: 27.2; [PATCH] Fix problems with 'C-c C-n' in sh-script-mode

From: [email-masked]
Date: Thu, 23 Sep 2021 18:28:21 +0200

Scenario: we are editing a buffer in 'shell-script-mode' and a *shell*
buffer doesn't exist yet.

In Emacs 27, pressing 'C-c C-n' creates a shell buffer and displays it
in a separate window by default.  This is less annoying than displaying
it in the selected window, which is what Emacs 28 currently does by
default, so this patch reverts that.

It also fixes a subtle bug, where a local variable is set in an
incorrect buffer.

Best regards.

From 84cdc5fd707baa2537cc57a77cec4ea537c4f308 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Miha=20Rihtar=C5=A1i=C4=8D?= <[email-masked]>
Date: Thu, 23 Sep 2021 18:03:24 +0200
Subject: [PATCH] Fix problems with 'C-c C-n' in sh-script-mode

* lisp/progmodes/sh-script.el (sh-shell-process): If a *shell* buffer
doesn't exist, 'C-c C-n' creates one and displays it.  This patch
prevents it from being displayed in the selected window.
Additionally, it ensures that the local `sh-shell-process' variable is
set in the correct buffer.
---
 lisp/progmodes/sh-script.el | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

diff --git a/lisp/progmodes/sh-script.el b/lisp/progmodes/sh-script.el
index cccd70f06c..3b6774aa14 100644
--- a/lisp/progmodes/sh-script.el
+++ b/lisp/progmodes/sh-script.el
@@ -1396,8 +1396,15 @@ sh-shell-process
             (or found
                 (and force
                      (get-buffer-process
-                      (let ((explicit-shell-file-name sh-shell-file))
-                        (shell)))))))))
+                      (let ((explicit-shell-file-name sh-shell-file)
+                            (display-buffer-overriding-action
+                             '(nil . ((inhibit-same-window . t)))))
+                        ;; We must prevent this `(shell)' call from
+                        ;; switching buffers, so that the variable
+                        ;; `sh-shell-process' is set locally in the
+                        ;; correct buffer.
+                        (save-current-buffer
+                          (shell))))))))))
 
 (defun sh-show-shell ()
   "Pop the shell interaction buffer."
-- 
2.33.0